var ITF = {};

var app = new Ox.App({
  apiURL: '/api/',
  init: 'hello',
  config: 'site.json' //FIXME: shouldn't need this, get data with 'hello' or 'init'.
});

app.launch(function(data) {
  Ox.theme("classic");
  Ox.print(data);

  app.$body = $('body');
  app.$document = $(document);
  app.$window = $(window);
/*
  app.user = data.user;
  app.config = data.config;
*/

/*
  //FIXME: should this be a nested structure as their representation on the page?
  app.constructors = ['wrapper', 'headerPanel', 'mainPanel', 'leftPanel', 'cityPicker', 'calendarBox', 'currentEventsList', 'middlePanel', 'middleTopPanel', 'newsfeedBox', 'aboutBox', 'itfBox', 'middleBottomPanel', 'erangBox', 'scriptArchiveBox', 'bestPracticesBox', 'biblioBox', 'offersNeedsBox', 'surveysBox', 'rightPanel', 'searchBox', 'loginBox', 'previewBox', 'footerPanel']
*/

  app.$ui = {};
/*
  Ox.each(app.constructors, function(i, v) {
    app.$ui[v] = app.construct[v]();
  });
*/
  var wrapper = app.construct.wrapper();
  app.$body.css({'opacity': 0});
  wrapper.appendTo(app.$body);
  app.$body.animate({
    'opacity': 1
  }, 2000);


/*
  //FIXME: make sure to add a loading icon
  Ox.Request.requests() && app.$ui.loadingIcon.start();
  Ox.Event.bind('', 'requestStart', function() {
      Ox.print('requestStart')
      app.$ui.loadingIcon.start();
  });
  Ox.Event.bind('', 'requestStop', function() {
      Ox.print('requestStop')
      app.$ui.loadingIcon.stop();
  });
*/

//  $(body).append(app.$ui.wrapper);
    
});

app.Query = (function() {

    function constructFind(query) {
        Ox.print('cF', query)
        return /*encodeURI(*/$.map(query.conditions, function(v, i) {
            if (!Ox.isUndefined(v.conditions)) {
                return '[' + constructFind(v) + ']';
            } else {
                return v.value !== '' ? v.key + (v.key ? ':' : '') + constructValue(v.value, v.operator) : null;
            }
        }).join(query.operator)/*)*/;
    }

    function constructValue(value, operator) {
        operator = operator.replace('=', '^$');
        if (operator.indexOf('$') > -1) {
            value = operator.substr(0, operator.length - 1) + value + '$'
        } else {
            value = operator + value;
        }
        return value;
    }

    function mergeFind() {
    }

    function parseFind(str) {
        var find = {
                conditions: [],
                operator: ''
            },
            subconditions = str.match(/\[.*?\]/g) || [];
        $.each(subconditions, function(i, v) {
            subconditions[i] = v.substr(1, v.length - 2);
            str = str.replace(v, '[' + i + ']');
        });
        if (str.indexOf(',') > -1) {
            find.operator = '&';
        } else if (str.indexOf('|') > -1) {
            find.operator = '|';
        }
        Ox.print('pF', str, find.operator)
        find.conditions = $.map(find.operator === '' ? [str] : str.split(find.operator == '&' ? ',' : '|'), function(v, i) {
            Ox.print('v', v)
            var ret, kv;
            if (v[0] == '[') {
                Ox.print('recursion', subconditions)
                ret = parseFind(subconditions[parseInt(v.substr(1, v.length - 2))]);
            } else {
                kv = ((v.indexOf(':') > - 1 ? '' : ':') + v).split(':');
                ret = $.extend({
                    key: kv[0]
                }, parseValue(kv[1]));
            }
            return ret;
        });
        return find;
    }

    function parseValue(str) {
        var value = {
                value: decodeURI(str),
                operator: ''
            };
        if (value.value[0] == '!') {
            value.operator = '!'
            value.value = value.value.substr(1);
        }
        if ('^<>'.indexOf(value.value[0]) > -1) {
            value.operator += value.value[0];
            value.value = value.value.substr(1);
        }
        if (value.value.substr(-1) == '$') {
            value.operator += '$';
            value.value = value.value.substr(0, value.value.length - 1);
        }
        value.operator = value.operator.replace('^$', '=');
        return value;
    }

    return {

        fromString: function(str) {
            var query = Ox.unserialize(str),
                sort = [];
            if ('find' in query) {
                app.user.ui.findQuery = parseFind(query.find);
                Ox.print('user.ui.findQuery', app.user.ui.findQuery)
            }
            if ('sort' in query) {
                sort = query.sort.split(',')
                app.user.ui.sort = $.map(query.sort.split(','), function(v, i) {
                    var hasOperator = '+-'.indexOf(v[0]) > -1,
                        key = hasOperator ? query.sort.substr(1) : query.sort,
                        operator = hasOperator ? v[0].replace('+', '') : Ox.getObjectById(app.config.sortKeys, key).operator;
                    return {
                        key: key,
                        operator: operator
                    };
                });
            }
            if ('view' in query) {
                app.user.ui.listView = query.view;
            }
        },

        toObject: function(groupId) {
            Ox.print('tO', app.user.ui.findQuery.conditions)
            // the inner $.merge() creates a clone
            var conditions = $.merge($.merge([], app.user.ui.listQuery.conditions), app.user.ui.findQuery.conditions);
            $.merge(conditions, app.ui.groups ? $.map(app.ui.groups, function(v, i) {
                    if (v.id != groupId && v.query.conditions.length) {
                        return v.query.conditions.length == 1 ?
                            v.query.conditions : v.query;
                    }
                }) : []),
                operator = conditions.length < 2 ? '' : ','; // fixme: should be &
            Ox.print('>>', groupId, app.user.ui.find, conditions);
            return {
                conditions: conditions,
                operator: operator
            };
        },

        toString: function() {
            Ox.print('tS', app.user.ui.find)
            return Ox.serialize({
                find: constructFind(app.Query.toObject()),
                sort: app.user.ui.sort[0].operator + app.user.ui.sort[0].key,
                view: app.user.ui.listView
            });
        }

    };

})();


app.construct = {
/*
Structure:
  wrapper
    headerPanel
      homeBox
      searchBox
    mainPanel
      leftPanel
        cityPicker
        calendarBox
        currentEventsList
      middlePanel
        middleTopPanel
          newsfeedBox
          aboutBox
          itfBox
        middleMiddlePanel
          erangBox
          scriptArchiveBox
          bestPracticesBox
        middleBottomPanel
          biblioBox
          offersNeedsBox
          surveysBox
      rightPanel
        loginBox
        previewBox        
    footerPanel
*/


  'wrapper': function() {
    var id = 'wrapper';
  // Constructs overall wrapper for the page, and should be appended to $(body)
    return app.$ui[id] = new Ox.SplitPanel({
      id: id,
      orientation: 'vertical',
      elements: [
        {
          element: app.construct.headerPanel(),
          size: 40
        },
        {
          element: app.construct.mainPanel(), 
        },
        {
          element: app.construct.footerPanel(),
          size: 40
        }
      ]
    });
  },

/*
BEGIN headerPanel
*/
  'headerPanel': function() {
    var id = 'headerPanel';
    var p = app.$ui[id] = new Ox.SplitPanel({
      orientation: 'horizontal',
      id: id,
      elements: [
        {
          element: app.construct.homeBox(),
        },
        {
          element: app.construct.searchBox(),
          size: 128

        }
      ]
    });
    return p;    
  },

  'homeBox': function() {
    var id = 'homeBox';
    var c = app.$ui.homeBox = new Ox.Element({
      id: id
    });
    c.html("This is the header - maybe load from a template?");
    return c;
  },

  'searchBox': function() {
    var id = 'searchBox';
    var i = app.$ui.searchBox = new Ox.Input({
      'id': id,
      'placeholder': 'Search'  
    });
    i.bindEvent("submit", function(val) {
      Ox.print("Should be doing a search");
    });
    i.css({
      'marginRight': '15px',
      'marginTop': '6px'
    });
    return i;
  },

/*
END headerPanel
*/

/*
BEGIN mainPanel
*/

  'mainPanel': function() {
    var id = 'mainPanel';
    var p = app.$ui[id] = new Ox.SplitPanel({
      id: id,
      orientation: 'horizontal',
      elements: [
        {
          element: app.construct.leftPanel(),
          size: 256,
//          resizable: true,
//          resize: [0, 128, 256, 384]
        },
        {
          element: app.construct.middlePanel()
//          resizable: true
        },
        {
          element: app.construct.rightPanel(),
          size: 256,
//          resizable: true,
//          resize: [0, 128, 256, 384]
        }
      ]
    });
    return p;
  },

  /*
  BEGIN leftPanel
  */
  'leftPanel': function() {
    var id = 'leftPanel';
    var p = app.$ui[id] = new Ox.SplitPanel({
      id: id,
      orientation: 'vertical',
      elements: [
        {
          element: app.construct.cityPicker(),
          size: 40
        },
        {
          element: app.construct.calendarBox()
        },
        {
          element: app.construct.currentEventsList(),
          size: 300
        }
      ]      
    });
    return p;
  },

  'cityPicker': function() {
    var id = 'cityPicker';
    var i = app.$ui[id] = new Ox.Input({
      id: id,
      placeholder: 'Chose Your City',
      autocomplete: ['Mumbai', 'Gurgaon', 'Agra', 'Delhi', 'Bangalore', 'Calcutta', 'Hyderabad'],
      autocompleteSelect: true,
      autocompleteSelectHighlight: true,
      autocompleteSelectSubmit: true,
      autocompleteReplaceCorrect: true
    });
    i.bindEvent("submit", function(event, data) {
      Ox.print(data);
//      alert(data.value);
    });
    return i;
  },

  'calendarBox': function() {
    var id = 'calendarBox';
    var c = app.$ui[id] = new Ox.Element({
      id: id
    });
    c.html("somehow, the bookmyshow calendar goes here.");
    return c;
  },

  'currentEventsList': function() {
    var id = 'currentEventsList';
    var c = app.$ui[id] = new Ox.Element({
      id: id
    });
    c.html("List of current events");
    return c;
  },
  /*
  END leftPanel
  */

  /*
  BEGIN middlePanel
  */
  'middlePanel': function() {
    var id = 'middlePanel';
    var p = app.$ui[id] = new Ox.SplitPanel({
      orientation: 'vertical',
      id: id,
      elements: [
        {
          element: app.construct.middleTopPanel(),
          size: 128,
//          resizable: true,
//          resize: [0, 64, 128, 196, 256],
//          collapsible: true
        },
        {
          element: app.construct.middleMiddlePanel(),
//          collapsible: true
        },
        {
          element: app.construct.middleBottomPanel(),
          size: 128,
//         resizable: true,
//          resize: [0, 64, 128, 196, 256],
//          collapsible: true
        }
      ]
    });
    return p;
  },

    /*
    BEGIN middleTopPanel
    */
  'middleTopPanel': function() {
    var id = 'middleTopPanel';
    var p = app.$ui[id] = new Ox.SplitPanel({
      id: id,
      orientation: 'horizontal',
      elements: [
        {
          element: app.construct.newsfeedBox(),
          size: 256
        },
        {
          element: app.construct.aboutBox()
        },
        {
          element: app.construct.itfBox(),
          size: 256
        }
      ]        
    });
    return p;
  },

  'newsfeedBox': function() {
    var id = 'newsfeedBox';
    var c = app.$ui[id] = new Ox.Element({
      id: id,
      title: 'ITF NewsFeed'
    });
    for (var i=0; i<25; i++) {
      var content = new Ox.Element().html('newsfeed content goes here');
      c.append(content);
    }
    return c;
  },

  'aboutBox': function() {
    var id = 'aboutBox';
    var c = app.$ui[id] = new Ox.Element({
      id: id,
      title: 'About'
    });
    c.html("about goes here");
    return c;        
  },

  'itfBox': function() {
    var id = 'itfBox';
    var c = app.$ui[id] = new Ox.Element({
      id: id
    });
    c.html("about itf goes here");
    return c;
  },
    /*
    END middleTopPanel
    */       

    /* 
    BEGIN middleMiddlePanel
    */

  'middleMiddlePanel': function() {
    var id = 'middleMiddlePanel';
    var p = app.$ui[id] = new Ox.SplitPanel({
      id: id,
      orientation: 'horizontal',
      elements: [
        {
          element: app.construct.erangBox(),
          size: 256
        },
        {
          element: app.construct.scriptArchiveBox()
        },
        {
          element: app.construct.bestPracticesBox(),
          size: 256
        }
      ]
    });
    return p;
  },

  'erangBox': function() {
    var id = 'erangBox';
    var c = app.$ui[id] = new Ox.Element({
      id: id
    });
    c.html("erang goes here");
    return c;
  },

  'scriptArchiveBox': function() {
    var id = 'scriptbankBox';
    var c = app.$ui[id] = new Ox.ItfBox({
      'id': id,
      'title': 'Script Bank',
      'module': 'scriptbank',
      'model': 'Script',
      'info': 'Script Archives are great, etc.'
    });
//    c.html("script archive goes here");
    return c;
  },

  'bestPracticesBox': function() {
    var id = 'bestpracticesBox';
    var title = "Best Practices";
    var module = "bestpractices";
    var model = "BestPractice";
    var info = "Some best practices lorem ipsum";
    var c = app.$ui[id] = new Ox.ItfBox({
      'id': id,
      'title': 'Best Practices',
      'module': 'bestpractices',
      'model': 'BestPractice',
      'info': 'Some best practices lorem ipsum'
/*
      'preview': function(data, callback) {
        var selectedId = data.ids[0];
        app.api.preview({
          'model': model,
          'module': module,
          'data': {'id': selectedId}
        }, callback);
      }
*/
    });
//    c.html("best practices goes here");
    return c;
  },

    /*
    END middleMiddlePanel
    */

    /*
    BEGIN middleBottomPanel    
    */
  'middleBottomPanel': function() {
    var id = 'middleBottomPanel';
    var p = app.$ui[id] = new Ox.SplitPanel({
      id: id,
      orientation: 'horizontal',
      elements: [
        {
          element: app.construct.biblioBox(),
          size: 256
        },
        {
          element: app.construct.offersNeedsBox()
        },
        {
          element: app.construct.surveysBox(),
          size: 256
        }
      ]
    });
    return p;
  },    
  
  'biblioBox': function() {
    var id = 'biblioBox';
    var c = app.$ui[id] = new Ox.Element({
      id: id
    });
    c.html("biblioBox here");
    return c;
  },

  'offersNeedsBox': function() {
    var id = 'offersNeedsBox';
    var c = app.$ui[id] = new Ox.Element({
      id: id
    });
    c.html("offers and needs here");
    return c;
  },

  'surveysBox': function() {
    var id = 'surveysBox';
    var c = app.$ui[id] = new Ox.Element({
      id: id
    });
    c.html("surveys go here");
    return c;
  },

    /*
    END middleBottomPanel
    */

  /*
  END middlePanel
  */

  /*
  BEGIN rightPanel
  */

  'rightPanel': function() {
    var id = 'rightPanel';
    var p = app.$ui[id] = new Ox.SplitPanel({
      id: id,
      orientation: 'vertical',
      elements: [
        {
          element: app.construct.loginBox(),
          size: 256
        },
        {
          element: app.construct.previewBox()
        }
      ]
    });
    return p;
  },

  'loginBox': function() {
    var id = 'loginBox';
    var c = app.$ui[id] = new Ox.Element({
      id: id
    });
    c.html("login goes here");
    return c;
  },

  'previewBox': function() {
    var id = 'previewBox';
    var c = app.$ui[id] = new Ox.ItfPreview({
      id: id
    });
    c.$content.html("previews here");
    return c;
  },

  /*
  END rightPanel
  */

/*
END mainPanel
*/

/*
BEGIN footerPanel
*/
  'footerPanel': function() {
    var id = 'footerPanel';
    var c = app.$ui[id] = new Ox.Element({
      id: id
    });
    c.html("footer goes here");
    return c;
  }
/*
END footerPanel
*/
}



/*
Ox.Box - generic box element, with a bar, some help, search, a menu, etc.
*/

Ox.ItfBox = function(options, self) {
  var self = self || {};
  var that = new Ox.Element(options, self)
    .defaults({
      'title': ''  
    })
    .options(options);
  var title = self.options.title; 
  var $titlebar = new Ox.Bar({
          orientation: 'horizontal',
          size: 18
      })
//      .dblclick(dblclickTitlebar)
      .appendTo(that);


  var $title = new Ox.Element()
      .addClass('OxTitle')
      .html(title/*.toUpperCase()*/)
      .appendTo($titlebar);


  var $search = new Ox.Input({
    'placeholder': 'Search',
  })
  .css({'width': '128px', 'marginLeft': 'auto', 'marginRight': 'auto'})
  .appendTo(that)
  .hide()
  .bindEvent("submit", function(value) {
    $list.options("request", function(data, callback) {
      return app.api.find(getQueryParams(data), callback)
    });
  });


  var $buttons = new Ox.Element().appendTo($title).css({'position': 'absolute', 'top': '1px', 'right': '1px'});

  that.$loading = new Ox.LoadingIcon().appendTo($buttons);
  var $infoBtn = new Ox.Button({
    id: options.id + "InfoBtn",
    style: 'symbold',
    title: 'info',
    type: 'image',
    tooltip: 'More info about ' + options.title 
  })
    .appendTo($buttons)
    .bindEvent("click", function() {
      var info = options.info;
      var d = new Ox.Dialog({
        buttons: [
          new Ox.Button({
            id: 'cancel',
            title: 'Close',
            })
            .bindEvent("click", function() { d.close(); })
        ],
        content: new Ox.Element().html(info),
        title: options.title
      })
      .open();
    });

  var $searchBtn = new Ox.Button({
          id: options.id + 'SearchBtn',
          style: 'symbol',
          title: 'find',
          type: 'image',
          tooltip: 'Search'
      })
      
      .bindEvent("click", function() {
//        alert("foo");
//        $search.slideDown();
        $search.is(":visible") ? $search.slideUp() : $search.slideDown();
        $search.focus();
      })
      .appendTo($buttons);
 

  var $menuBtn = new Ox.Button({
    id: options.id + 'MenuBtn',
    style: 'symbol',
    title: 'collapse',
    type: 'image',
    tooltip: 'Show Menu'
  }).appendTo($buttons);

  var $menu = new Ox.Menu({
    id: options.id + 'Menu',
    element: $menuBtn,
    items: [
      {id: 'Test', title: 'Menu Item 1'},
      {id: 'Test2', title: 'Menu Item 2'}
    ]
  });
  
  $menuBtn.bindEvent("click", function() {
    $menu.showMenu();
  });

  function getQueryParams(data) {
//    Ox.print("SEARCHVAL", $search.val());
    return $.extend(data, {
      'search': $search.value() == 'Search' ? '' : $search.value(),
      'model': options.model,
      'module': options.module
    });
  }

  var $listContainer = new Ox.Element()
    .appendTo(that)
    .css({position: 'relative', height: '100%'});

  var listOptions = $.extend(options, {
      'width': 256,
//      'itemHeight': 16,
//      'itemWidth': 250,
//      'orientation': 'horizontal',
      'request': function(data, callback) {
        return app.api.find(getQueryParams(data), callback)
      },
      'id': options.id + 'List',
      'boxId': options.id,
      

/*
      'construct': function(data) {
        var $a = $('<a />').attr("href", "/" + options.module.toLowerCase() + "/" + data.id).text(data.title); 
        var $item = $('<div />').addClass('OxTarget').append($a);
        return $item;
      },
*/
      'max': 1,
      'columns': [
        {
          align: 'left',
          id: 'title',
          operator: '-',
          unique: false,
          visible: true,
          width: 230
        },
        {
          id: 'id',
          visible: false,
          unique: true  
        }
      ],
      'sort': [{
        key: 'title',
        operator: '-'
      }]        
    });

  var $list = new Ox.ItfList(listOptions)
    .appendTo($listContainer);

  return that;   
}

Ox.ItfList = function(options, self) {
  var self = self || {};
  var that = new Ox.TextList(options, self);
  that.bindEvent("select", function(e, data) {
    app.$ui[options.boxId].$loading.start();
//    debugger;
    app.api.preview({
      model: options.model,
      module: options.module,
      id: data.ids[0]
    }, function(response) {
//      alert(JSON.stringify(response.data.data));
      app.$ui[options.boxId].$loading.stop();
      var html = $.tmpl(response['template'], response['data']);
      app.$ui.previewBox.$content.html(html);
    }); 
  });
  that.bindEvent("open", function(e, data) {
//    alert(JSON.stringify(data));
    app.$ui[options.boxId].$loading.start();
    app.api.info({
      model: options.model,
      module: options.module,
      id: data.ids[0] 
    }, function(response) {
      app.$ui[options.boxId].$loading.stop();
      var html = $.tmpl(response['template'], response['data']);
//      alert(html);
      var d = new Ox.Dialog({
        buttons: [
          new Ox.Button({
            id: 'cancel',
            title: 'Close',
            })
            .bindEvent("click", function() { d.close(); })
        ],
        content: new Ox.Element().append(html),
        title: options.title + ": " + response.data.title,
        width: 800,
        height: 500
      })
      .open();
//      alert(response);      
    });
  });
  return that;
}

Ox.ItfCalendar = function(options, self) {
  var self = self || {};
  var that = new Ox.Element(options, self);
  var $titleBar = new Ox.Bar({
    'size': 'small'
  }).addClass('OxTitleBar').appendTo(that);
  var $title = new Ox.Element().html("Calendar").appendTo($titleBar);
  return that;
}

Ox.ItfPreview = function(options, self) {
  var self = self || {};
  var that = new Ox.Element(options, self);
  that.$content = new Ox.Element().appendTo(that);
  that.$loading = new Ox.LoadingIcon().appendTo(that);
  return that;
}

ITF.templates = {};

